<template>
  <v-dialog max-width="600px" v-model="dialog">
    <v-btn flat slot="activator" class="primary white--text">
      <v-icon left>add</v-icon>Add Movie
    </v-btn>
    <v-card>
      <v-card-title>
        <h2 class="font-weight-regular grey--text text--darken-1">
          Add A New Movie
        </h2>
      </v-card-title>
      <v-card-text>
        <v-form class="px-" ref="newMovieForm">
          <v-text-field
            label="Movie Name"
            v-model="name"
            prepend-icon="folder"
            :rules="nameRules"
          />
          <v-text-field
            label="Price"
            v-model="price"
            prepend-icon="attach_money"
            :rules="priceRules"
          />
          <v-autocomplete
            prepend-icon="calendar_today"
            label="Year"
            v-model="year"
            :items="this.getYears()"
            :rules="yearRules"
          />
          <v-btn class="primary" flat @click="submit">Add Movie</v-btn>
        </v-form>
      </v-card-text>
    </v-card>
  </v-dialog>
</template>
<script>
import validations from "../validations/validations";
const { isRequired, isStringShorterThan, isBetween } = validations;

export default {
  data() {
    return {
      name: null,
      price: null,
      year: null,
      dialog: false,
      nameRules: [isRequired(), isStringShorterThan(150)],
      priceRules: [isRequired(), isBetween(0, 100)],
      yearRules: [isRequired()]
    };
  },
  methods: {
    async submit() {
      if (this.$refs.newMovieForm.validate()) {
        this.$store.dispatch("movies/insert", this.getMovieObject());
        this.$store.dispatch("navBar/closeDrawer");
      }
    },
    getYears() {
      const years = [];
      for (let i = new Date().getFullYear(); i >= 1900; i--) {
        years.push(i);
      }
      return years;
    },
    getMovieObject() {
      return {
        name: this.name,
        price: parseFloat(this.price),
        year: parseInt(this.year)
      };
    }
  }
};
</script>
